﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using System.Drawing;
using System.IO;
using System.Windows.Forms;

namespace Xenon.Aims.SceneGraph
{


    public abstract class Actions_File
    {


        #region アクション
        //────────────────────────────────────────

        public static void Save(UcMain ucMain)
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("<?xml version=\"1.0\" encoding=\"UTF-8\"?>");
            sb.Append(Environment.NewLine);
            sb.Append("<scene-tunageru>");
            sb.Append(Environment.NewLine);

            // ──────────
            // UiMain
            // ──────────
            sb.Append("  <ui-main");
            sb.Append(" font-name=\"" + ucMain.Font.Name + "\" font-size=\"" + ucMain.Font.Size + "\"");
            sb.Append(" coord-mat-repeat-x=\"" + ucMain.CoordMatRepeatX + "\" coord-mat-repeat-y=\"" + ucMain.CoordMatRepeatY + "\"");
            sb.Append(" />");
            sb.Append(Environment.NewLine);

            // ──────────
            // 座標マット
            // ──────────
            ucMain.CoordMat.Save(sb);

            // ──────────
            // 全シーン
            // ──────────
            ucMain.Boxes.Save(sb);

            sb.Append("</scene-tunageru>");
            sb.Append(Environment.NewLine);
            string xml = sb.ToString();

            // テキストファイルとして上書き。
            System.IO.File.WriteAllText("save.xml", xml, Encoding.UTF8);

            // ──────────
            // バックアップファイル
            // ──────────
            //タイムスタンプ
            string timestamp;
            {
                StringBuilder s = new StringBuilder();
                DateTime now = System.DateTime.Now;
                s.Append(String.Format("{0:D4}", now.Year));
                s.Append(String.Format("{0:D2}", now.Month));
                s.Append(String.Format("{0:D2}", now.Day));
                s.Append("_");
                s.Append(String.Format("{0:D2}", now.Hour));
                s.Append(String.Format("{0:D2}", now.Minute));
                s.Append(String.Format("{0:D2}", now.Second));
                s.Append(String.Format("{0:D3}", now.Millisecond));
                timestamp = s.ToString();
            }
            System.IO.File.WriteAllText("BK_" + timestamp + "_save.xml", xml, Encoding.UTF8);
        }

        //────────────────────────────────────────

        public static void ScreenShot(UcMain ucMain1)
        {
            //タイムスタンプ
            string timestamp;
            {
                StringBuilder s = new StringBuilder();
                DateTime now = System.DateTime.Now;
                s.Append(String.Format("{0:D4}", now.Year));
                s.Append(String.Format("{0:D2}", now.Month));
                s.Append(String.Format("{0:D2}", now.Day));
                s.Append("_");
                s.Append(String.Format("{0:D2}", now.Hour));
                s.Append(String.Format("{0:D2}", now.Minute));
                s.Append("_");
                s.Append(String.Format("{0:D2}", now.Second));
                s.Append(String.Format("{0:D3}", now.Millisecond));
                timestamp = s.ToString();
            }

            for (int r = 0; r < ucMain1.CoordMatRepeatY; r++)
            {
                for (int c = 0; c < ucMain1.CoordMatRepeatX; c++)
                {
                    // Graphicsオブジェクトを取得
                    Graphics g = null;

                    try
                    {
                        Bitmap bitmap;
                        bitmap = new Bitmap(ucMain1.CoordMat.Bounds.Width, ucMain1.CoordMat.Bounds.Height);
                        g = Graphics.FromImage(bitmap);

                        // 背景を白色で塗りつぶします。
                        g.FillRectangle(Brushes.White, 0, 0, ucMain1.CoordMat.Bounds.Width, ucMain1.CoordMat.Bounds.Height);

                        // ──────────
                        // 座標マット　描画
                        // ──────────
                        ucMain1.CoordMat.FileName = r + "_" + c + ".png";
                        Rectangle old2 = new Rectangle(
                            ucMain1.CoordMat.SourceBounds.X,
                            ucMain1.CoordMat.SourceBounds.Y,
                            ucMain1.CoordMat.SourceBounds.Width,
                            ucMain1.CoordMat.SourceBounds.Height
                            );
                        ucMain1.CoordMat.SourceBounds = new Rectangle(
                            0,
                            0,
                            ucMain1.CoordMat.Bounds.Width,
                            ucMain1.CoordMat.Bounds.Height
                            );
                        bool isSelected2 = ucMain1.CoordMat.IsSelected;
                        ucMain1.CoordMat.IsSelected = false;
                        ucMain1.CoordMat.Paint(g, ucMain1);
                        ucMain1.CoordMat.SourceBounds = old2;
                        ucMain1.CoordMat.IsSelected = isSelected2;


                        // ──────────
                        // 全シーン　描画
                        // ──────────
                        ucMain1.Boxes.Screenshot(g, ucMain1, r, c);



                        // 画像ファイルを書き出します。
                        bitmap.Save(Path.Combine(Application.StartupPath, timestamp + "_" + r + "_" + c + ".png"), System.Drawing.Imaging.ImageFormat.Png);
                    }
                    finally
                    {
                        if (null != g)
                        {
                            g.Dispose();
                        }
                    }
                }
            }
        }

        //────────────────────────────────────────
        #endregion


    }


}
